preparing for 2.10.3
[git/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
4c8a9db6 3# git-submodule.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
681b036f 8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 10 or: $dashless [--quiet] init [--] [<path>...]
f6a52799 11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
abed000a 12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
adc54235 13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 14 or: $dashless [--quiet] foreach [--recursive] <command>
82f49f29 15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
8f321a39 16OPTIONS_SPEC=
091a6eb0 17SUBDIRECTORY_OK=Yes
70c7ac22 18. git-sh-setup
98fcf840 19. git-parse-remote
70c7ac22 20require_work_tree
091a6eb0
JK
21wt_prefix=$(git rev-parse --show-prefix)
22cd_to_toplevel
70c7ac22 23
33cfccbb
JK
24# Restrict ourselves to a vanilla subset of protocols; the URLs
25# we get are under control of a remote repository, and we do not
26# want them kicking off arbitrary git-remote-* programs.
27#
28# If the user has already specified a set of allowed protocols,
29# we assume they know what they're doing and use that instead.
30: ${GIT_ALLOW_PROTOCOL=file:git:http:https:ssh}
31export GIT_ALLOW_PROTOCOL
32
5c08dbbd 33command=
ecda0723 34branch=
d27b876b 35force=
d92a3959 36reference=
70c7ac22 37cached=
48bb3033
GP
38recursive=
39init=
1c244f6e 40files=
06b1abb5 41remote=
31ca3ac3 42nofetch=
32948425 43update=
15fc56a8 44prefix=
73b0898d 45custom_name=
275cd184 46depth=
70c7ac22 47
be9d0a3a
HV
48die_if_unmatched ()
49{
50 if test "$1" = "#unmatched"
51 then
c4c02bf1 52 exit ${2:-1}
be9d0a3a
HV
53 fi
54}
55
88ce00c3
TK
56#
57# Print a submodule configuration setting
58#
59# $1 = submodule name
60# $2 = option name
61# $3 = default value
62#
63# Checks in the usual git-config places first (for overrides),
64# otherwise it falls back on .gitmodules. This allows you to
65# distribute project-wide defaults in .gitmodules, while still
66# customizing individual repositories if necessary. If the option is
67# not in .gitmodules either, print a default value.
68#
69get_submodule_config () {
70 name="$1"
71 option="$2"
72 default="$3"
73 value=$(git config submodule."$name"."$option")
74 if test -z "$value"
75 then
76 value=$(git config -f .gitmodules submodule."$name"."$option")
77 fi
78 printf '%s' "${value:-$default}"
79}
80
862ae6cd
RS
81isnumber()
82{
83 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
84}
85
14111fc4
JK
86# Sanitize the local git environment for use within a submodule. We
87# can't simply use clear_local_git_env since we want to preserve some
88# of the settings from GIT_CONFIG_PARAMETERS.
89sanitize_submodule_env()
90{
89044baa 91 save_config=$GIT_CONFIG_PARAMETERS
14111fc4 92 clear_local_git_env
89044baa 93 GIT_CONFIG_PARAMETERS=$save_config
860cba61 94 export GIT_CONFIG_PARAMETERS
14111fc4
JK
95}
96
ecda0723
SV
97#
98# Add a new submodule to the working tree, .gitmodules and the index
99#
ec05df35 100# $@ = repo path
ecda0723
SV
101#
102# optional branch is stored in global branch variable
103#
23a485e3 104cmd_add()
ecda0723 105{
5c08dbbd 106 # parse $args after "submodule ... add".
091a6eb0 107 reference_path=
5c08dbbd
JH
108 while test $# -ne 0
109 do
110 case "$1" in
111 -b | --branch)
112 case "$2" in '') usage ;; esac
113 branch=$2
114 shift
115 ;;
d27b876b
JL
116 -f | --force)
117 force=$1
118 ;;
5c08dbbd 119 -q|--quiet)
2e6a30ef 120 GIT_QUIET=1
5c08dbbd 121 ;;
d92a3959
MT
122 --reference)
123 case "$2" in '') usage ;; esac
091a6eb0 124 reference_path=$2
d92a3959
MT
125 shift
126 ;;
127 --reference=*)
091a6eb0 128 reference_path="${1#--reference=}"
d92a3959 129 ;;
73b0898d
JL
130 --name)
131 case "$2" in '') usage ;; esac
132 custom_name=$2
133 shift
134 ;;
275cd184
FG
135 --depth)
136 case "$2" in '') usage ;; esac
137 depth="--depth=$2"
138 shift
139 ;;
140 --depth=*)
141 depth=$1
142 ;;
5c08dbbd
JH
143 --)
144 shift
145 break
146 ;;
147 -*)
148 usage
149 ;;
150 *)
151 break
152 ;;
153 esac
154 shift
155 done
156
091a6eb0
JK
157 if test -n "$reference_path"
158 then
159 is_absolute_path "$reference_path" ||
160 reference_path="$wt_prefix$reference_path"
161
162 reference="--reference=$reference_path"
163 fi
164
ecda0723 165 repo=$1
64394e3a 166 sm_path=$2
ecda0723 167
64394e3a 168 if test -z "$sm_path"; then
6a066230 169 sm_path=$(printf '%s\n' "$repo" |
1414e578
JL
170 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
171 fi
172
496eeeb1 173 if test -z "$repo" || test -z "$sm_path"; then
ecda0723
SV
174 usage
175 fi
176
091a6eb0
JK
177 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
178
ec05df35
ML
179 # assure repo is absolute or relative to parent
180 case "$repo" in
181 ./*|../*)
091a6eb0
JK
182 test -z "$wt_prefix" ||
183 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
184
ec05df35 185 # dereference source url relative to parent's url
63e95beb 186 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
ec05df35
ML
187 ;;
188 *:*|/*)
189 # absolute url
190 realrepo=$repo
191 ;;
192 *)
497ee872 193 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
194 ;;
195 esac
196
db75ada5
MG
197 # normalize path:
198 # multiple //; leading ./; /./; /../; trailing /
64394e3a 199 sm_path=$(printf '%s/\n' "$sm_path" |
db75ada5
MG
200 sed -e '
201 s|//*|/|g
202 s|^\(\./\)*||
8196e728 203 s|/\(\./\)*|/|g
db75ada5
MG
204 :start
205 s|\([^/]*\)/\.\./||
206 tstart
207 s|/*$||
208 ')
64394e3a
RJ
209 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
210 die "$(eval_gettext "'\$sm_path' already exists in the index")"
ecda0723 211
64394e3a 212 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
d27b876b 213 then
6ff875c5 214 eval_gettextln "The following path is ignored by one of your .gitignore files:
64394e3a 215\$sm_path
6ff875c5 216Use -f if you really want to add it." >&2
d27b876b
JL
217 exit 1
218 fi
219
73b0898d
JL
220 if test -n "$custom_name"
221 then
222 sm_name="$custom_name"
223 else
224 sm_name="$sm_path"
225 fi
226
d4264ca3 227 # perhaps the path exists and is already a git repo, else clone it
64394e3a 228 if test -e "$sm_path"
d4264ca3 229 then
496eeeb1 230 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
d4264ca3 231 then
64394e3a 232 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
d4264ca3 233 else
64394e3a 234 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
d4264ca3 235 fi
c2f93917 236
d4264ca3 237 else
4b7c286e
JL
238 if test -d ".git/modules/$sm_name"
239 then
240 if test -z "$force"
241 then
0d71dbfd 242 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
4b7c286e 243 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
0d71dbfd
VA
244 die "$(eval_gettextln "\
245If you want to reuse this local git directory instead of cloning again from
246 \$realrepo
247use the '--force' option. If the local git directory is not the correct repo
248or you are unsure what this means choose another name with the '--name' option.")"
4b7c286e 249 else
0d71dbfd 250 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
4b7c286e
JL
251 fi
252 fi
d10e3b42 253 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
d851ffb9 254 (
14111fc4 255 sanitize_submodule_env
d851ffb9
JH
256 cd "$sm_path" &&
257 # ash fails to wordsplit ${branch:+-b "$branch"...}
258 case "$branch" in
259 '') git checkout -f -q ;;
260 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
261 esac
262 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
d4264ca3 263 fi
73b0898d 264 git config submodule."$sm_name".url "$realrepo"
d4264ca3 265
64394e3a
RJ
266 git add $force "$sm_path" ||
267 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
ecda0723 268
73b0898d
JL
269 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
270 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
b9289227
TK
271 if test -n "$branch"
272 then
273 git config -f .gitmodules submodule."$sm_name".branch "$branch"
274 fi &&
31991b02 275 git add --force .gitmodules ||
64394e3a 276 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
ecda0723
SV
277}
278
19a31f9c
ML
279#
280# Execute an arbitrary command sequence in each checked out
281# submodule
282#
283# $@ = command to execute
284#
285cmd_foreach()
286{
1d5bec8b
JH
287 # parse $args after "submodule ... foreach".
288 while test $# -ne 0
289 do
290 case "$1" in
291 -q|--quiet)
292 GIT_QUIET=1
293 ;;
15fc56a8
JH
294 --recursive)
295 recursive=1
296 ;;
1d5bec8b
JH
297 -*)
298 usage
299 ;;
300 *)
301 break
302 ;;
303 esac
304 shift
305 done
306
f030c96d
ÆAB
307 toplevel=$(pwd)
308
4dca1aa6
BC
309 # dup stdin so that it can be restored when running the external
310 # command in the subshell (and a recursive call to this function)
311 exec 3<&0
312
b0f4b408
SB
313 {
314 git submodule--helper list --prefix "$wt_prefix" ||
c4c02bf1 315 echo "#unmatched" $?
b0f4b408 316 } |
64394e3a 317 while read mode sha1 stage sm_path
19a31f9c 318 do
c4c02bf1 319 die_if_unmatched "$mode" "$sha1"
64394e3a 320 if test -e "$sm_path"/.git
19a31f9c 321 then
44431df0 322 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
ea2fa104 323 say "$(eval_gettext "Entering '\$displaypath'")"
0ea306ef 324 name=$(git submodule--helper name "$sm_path")
15fc56a8 325 (
64394e3a 326 prefix="$prefix$sm_path/"
14111fc4 327 sanitize_submodule_env
64394e3a 328 cd "$sm_path" &&
44431df0 329 sm_path=$(git submodule--helper relative-path "$sm_path" "$wt_prefix") &&
091a6eb0
JK
330 # we make $path available to scripts ...
331 path=$sm_path &&
1c4fb136
AK
332 if test $# -eq 1
333 then
334 eval "$1"
335 else
336 "$@"
337 fi &&
15fc56a8
JH
338 if test -n "$recursive"
339 then
340 cmd_foreach "--recursive" "$@"
341 fi
4dca1aa6 342 ) <&3 3<&- ||
ea2fa104 343 die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
19a31f9c
ML
344 fi
345 done
346}
347
70c7ac22 348#
211b7f19 349# Register submodules in .git/config
70c7ac22
LH
350#
351# $@ = requested paths (default to all)
352#
23a485e3 353cmd_init()
70c7ac22 354{
5c08dbbd
JH
355 # parse $args after "submodule ... init".
356 while test $# -ne 0
357 do
358 case "$1" in
359 -q|--quiet)
2e6a30ef 360 GIT_QUIET=1
5c08dbbd
JH
361 ;;
362 --)
363 shift
364 break
365 ;;
366 -*)
367 usage
368 ;;
369 *)
370 break
371 ;;
372 esac
373 shift
374 done
375
3604242f 376 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper init ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} "$@"
70c7ac22
LH
377}
378
cf419828
JL
379#
380# Unregister submodules from .git/config and remove their work tree
381#
cf419828
JL
382cmd_deinit()
383{
384 # parse $args after "submodule ... deinit".
f6a52799 385 deinit_all=
cf419828
JL
386 while test $# -ne 0
387 do
388 case "$1" in
389 -f|--force)
390 force=$1
391 ;;
392 -q|--quiet)
393 GIT_QUIET=1
394 ;;
f6a52799
SB
395 --all)
396 deinit_all=t
397 ;;
cf419828
JL
398 --)
399 shift
400 break
401 ;;
402 -*)
403 usage
404 ;;
405 *)
406 break
407 ;;
408 esac
409 shift
410 done
411
f6a52799
SB
412 if test -n "$deinit_all" && test "$#" -ne 0
413 then
414 echo >&2 "$(eval_gettext "pathspec and --all are incompatible")"
415 usage
416 fi
417 if test $# = 0 && test -z "$deinit_all"
cf419828 418 then
f6a52799 419 die "$(eval_gettext "Use '--all' if you really want to deinitialize all submodules")"
cf419828
JL
420 fi
421
b0f4b408
SB
422 {
423 git submodule--helper list --prefix "$wt_prefix" "$@" ||
c4c02bf1 424 echo "#unmatched" $?
b0f4b408 425 } |
cf419828
JL
426 while read mode sha1 stage sm_path
427 do
c4c02bf1 428 die_if_unmatched "$mode" "$sha1"
0ea306ef 429 name=$(git submodule--helper name "$sm_path") || exit
cf419828 430
44431df0 431 displaypath=$(git submodule--helper relative-path "$sm_path" "$wt_prefix")
091a6eb0 432
cf419828
JL
433 # Remove the submodule work tree (unless the user already did it)
434 if test -d "$sm_path"
435 then
436 # Protect submodules containing a .git directory
437 if test -d "$sm_path/.git"
438 then
0d71dbfd
VA
439 die "$(eval_gettext "\
440Submodule work tree '\$displaypath' contains a .git directory
441(use 'rm -rf' if you really want to remove it including all of its history)")"
cf419828
JL
442 fi
443
444 if test -z "$force"
445 then
7b294bf4 446 git rm -qn "$sm_path" ||
091a6eb0 447 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
cf419828 448 fi
7b294bf4 449 rm -rf "$sm_path" &&
091a6eb0
JK
450 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
451 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
cf419828
JL
452 fi
453
091a6eb0 454 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
cf419828
JL
455
456 # Remove the .git/config entries (unless the user already did it)
457 if test -n "$(git config --get-regexp submodule."$name\.")"
458 then
459 # Remove the whole section so we have a clean state when
460 # the user later decides to init this submodule again
461 url=$(git config submodule."$name".url)
462 git config --remove-section submodule."$name" 2>/dev/null &&
091a6eb0 463 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
cf419828
JL
464 fi
465 done
466}
467
fb43e31f 468is_tip_reachable () (
01e1d544 469 sanitize_submodule_env &&
fb43e31f
SB
470 cd "$1" &&
471 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
472 test -z "$rev"
473)
474
475fetch_in_submodule () (
01e1d544 476 sanitize_submodule_env &&
fb43e31f
SB
477 cd "$1" &&
478 case "$2" in
479 '')
480 git fetch ;;
481 *)
6cbf454a
SB
482 shift
483 git fetch $(get_default_remote) "$@" ;;
fb43e31f
SB
484 esac
485)
486
70c7ac22 487#
211b7f19 488# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
489#
490# $@ = requested paths (default to all)
491#
23a485e3 492cmd_update()
70c7ac22 493{
5c08dbbd
JH
494 # parse $args after "submodule ... update".
495 while test $# -ne 0
496 do
497 case "$1" in
498 -q|--quiet)
2e6a30ef 499 GIT_QUIET=1
5c08dbbd 500 ;;
be4d2c83 501 -i|--init)
d92a3959 502 init=1
be4d2c83 503 ;;
06b1abb5
TK
504 --remote)
505 remote=1
506 ;;
31ca3ac3 507 -N|--no-fetch)
31ca3ac3
FF
508 nofetch=1
509 ;;
9db31bdf
NMC
510 -f|--force)
511 force=$1
512 ;;
ca2cedba 513 -r|--rebase)
32948425 514 update="rebase"
ca2cedba 515 ;;
d92a3959
MT
516 --reference)
517 case "$2" in '') usage ;; esac
518 reference="--reference=$2"
98dbe63d 519 shift
d92a3959
MT
520 ;;
521 --reference=*)
522 reference="$1"
d92a3959 523 ;;
42b49178 524 -m|--merge)
42b49178
JH
525 update="merge"
526 ;;
b13fd5c1 527 --recursive)
b13fd5c1
JH
528 recursive=1
529 ;;
efc5fb6a
JH
530 --checkout)
531 update="checkout"
532 ;;
abed000a
SB
533 --recommend-shallow)
534 recommend_shallow="--recommend-shallow"
535 ;;
536 --no-recommend-shallow)
537 recommend_shallow="--no-recommend-shallow"
538 ;;
275cd184
FG
539 --depth)
540 case "$2" in '') usage ;; esac
541 depth="--depth=$2"
542 shift
543 ;;
544 --depth=*)
545 depth=$1
546 ;;
2335b870
SB
547 -j|--jobs)
548 case "$2" in '') usage ;; esac
549 jobs="--jobs=$2"
550 shift
551 ;;
552 --jobs=*)
553 jobs=$1
554 ;;
5c08dbbd
JH
555 --)
556 shift
557 break
558 ;;
559 -*)
560 usage
561 ;;
562 *)
563 break
564 ;;
565 esac
98dbe63d 566 shift
5c08dbbd
JH
567 done
568
d92a3959
MT
569 if test -n "$init"
570 then
571 cmd_init "--" "$@" || return
572 fi
573
48308681
SB
574 {
575 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
576 ${wt_prefix:+--prefix "$wt_prefix"} \
577 ${prefix:+--recursive-prefix "$prefix"} \
578 ${update:+--update "$update"} \
579 ${reference:+--reference "$reference"} \
580 ${depth:+--depth "$depth"} \
abed000a 581 ${recommend_shallow:+"$recommend_shallow"} \
2335b870 582 ${jobs:+$jobs} \
c4c02bf1 583 "$@" || echo "#unmatched" $?
48308681 584 } | {
15ffb7cd 585 err=
48308681 586 while read mode sha1 stage just_cloned sm_path
70c7ac22 587 do
c4c02bf1 588 die_if_unmatched "$mode" "$sha1"
48308681 589
0ea306ef 590 name=$(git submodule--helper name "$sm_path") || exit
5be60078 591 url=$(git config submodule."$name".url)
efc5fb6a
JH
592 if ! test -z "$update"
593 then
594 update_module=$update
595 else
596 update_module=$(git config submodule."$name".update)
a2aed08b
TK
597 if test -z "$update_module"
598 then
599 update_module="checkout"
600 fi
efc5fb6a
JH
601 fi
602
44431df0 603 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
091a6eb0 604
48308681 605 if test $just_cloned -eq 1
d851ffb9 606 then
bf2d8246 607 subsha1=
48308681 608 update_module=checkout
bf2d8246 609 else
14111fc4 610 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
5be60078 611 git rev-parse --verify HEAD) ||
091a6eb0 612 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
70c7ac22 613 fi
211b7f19 614
06b1abb5
TK
615 if test -n "$remote"
616 then
92bbe7cc 617 branch=$(git submodule--helper remote-branch "$sm_path")
06b1abb5
TK
618 if test -z "$nofetch"
619 then
620 # Fetch remote before determining tracking $sha1
6cbf454a 621 fetch_in_submodule "$sm_path" $depth ||
06b1abb5
TK
622 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
623 fi
14111fc4
JK
624 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
625 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
06b1abb5 626 git rev-parse --verify "${remote_name}/${branch}") ||
c87302bf 627 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
06b1abb5
TK
628 fi
629
496eeeb1 630 if test "$subsha1" != "$sha1" || test -n "$force"
70c7ac22 631 then
9db31bdf
NMC
632 subforce=$force
633 # If we don't already have a -f flag and the submodule has never been checked out
496eeeb1 634 if test -z "$subsha1" && test -z "$force"
b9b378a0 635 then
9db31bdf 636 subforce="-f"
b9b378a0 637 fi
31ca3ac3
FF
638
639 if test -z "$nofetch"
640 then
e5f522d6
JL
641 # Run fetch only if $sha1 isn't present or it
642 # is not reachable from a ref.
fb43e31f 643 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 644 fetch_in_submodule "$sm_path" $depth ||
091a6eb0 645 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
fb43e31f
SB
646
647 # Now we tried the usual fetch, but $sha1 may
648 # not be reachable from any of the refs
649 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 650 fetch_in_submodule "$sm_path" $depth "$sha1" ||
c87302bf 651 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
31ca3ac3
FF
652 fi
653
877449c1 654 must_die_on_failure=
32948425 655 case "$update_module" in
a2aed08b
TK
656 checkout)
657 command="git checkout $subforce -q"
658 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
659 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
660 ;;
32948425
JH
661 rebase)
662 command="git rebase"
091a6eb0
JK
663 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
664 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
877449c1 665 must_die_on_failure=yes
32948425 666 ;;
42b49178
JH
667 merge)
668 command="git merge"
091a6eb0
JK
669 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
670 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
877449c1 671 must_die_on_failure=yes
42b49178 672 ;;
6cb5728c
CP
673 !*)
674 command="${update_module#!}"
b08238ac
SB
675 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
676 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
6cb5728c
CP
677 must_die_on_failure=yes
678 ;;
32948425 679 *)
a2aed08b 680 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
32948425 681 esac
70c7ac22 682
14111fc4 683 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
15ffb7cd 684 then
ff968f03 685 say "$say_msg"
877449c1
JH
686 elif test -n "$must_die_on_failure"
687 then
ff968f03 688 die_with_status 2 "$die_msg"
15ffb7cd 689 else
ff968f03 690 err="${err};$die_msg"
877449c1 691 continue
15ffb7cd 692 fi
70c7ac22 693 fi
b13fd5c1
JH
694
695 if test -n "$recursive"
696 then
75bf5e60 697 (
44431df0 698 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
3604242f 699 wt_prefix=
14111fc4 700 sanitize_submodule_env
75bf5e60 701 cd "$sm_path" &&
36141282 702 eval cmd_update
75bf5e60 703 )
15ffb7cd
FG
704 res=$?
705 if test $res -gt 0
706 then
091a6eb0 707 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
bb9d91b4 708 if test $res -ne 2
15ffb7cd 709 then
ff968f03 710 err="${err};$die_msg"
15ffb7cd
FG
711 continue
712 else
ff968f03 713 die_with_status $res "$die_msg"
15ffb7cd
FG
714 fi
715 fi
b13fd5c1 716 fi
70c7ac22 717 done
15ffb7cd
FG
718
719 if test -n "$err"
720 then
721 OIFS=$IFS
722 IFS=';'
723 for e in $err
724 do
725 if test -n "$e"
726 then
727 echo >&2 "$e"
728 fi
729 done
730 IFS=$OIFS
731 exit 1
732 fi
733 }
70c7ac22
LH
734}
735
bffe71f4
EM
736set_name_rev () {
737 revname=$( (
14111fc4 738 sanitize_submodule_env
bffe71f4 739 cd "$1" && {
5be60078
JH
740 git describe "$2" 2>/dev/null ||
741 git describe --tags "$2" 2>/dev/null ||
f669ac0b
ML
742 git describe --contains "$2" 2>/dev/null ||
743 git describe --all --always "$2"
bffe71f4
EM
744 }
745 ) )
746 test -z "$revname" || revname=" ($revname)"
747}
28f9af5d
PY
748#
749# Show commit summary for submodules in index or working tree
750#
751# If '--cached' is given, show summary between index and given commit,
752# or between working tree and given commit
753#
754# $@ = [commit (default 'HEAD'),] requested paths (default all)
755#
756cmd_summary() {
f2dc06a3 757 summary_limit=-1
d0f64dd4 758 for_status=
1c244f6e 759 diff_cmd=diff-index
f2dc06a3 760
28f9af5d
PY
761 # parse $args after "submodule ... summary".
762 while test $# -ne 0
763 do
764 case "$1" in
765 --cached)
766 cached="$1"
767 ;;
1c244f6e
JL
768 --files)
769 files="$1"
770 ;;
d0f64dd4
PY
771 --for-status)
772 for_status="$1"
773 ;;
f2dc06a3 774 -n|--summary-limit)
862ae6cd
RS
775 summary_limit="$2"
776 isnumber "$summary_limit" || usage
f2dc06a3
PY
777 shift
778 ;;
862ae6cd
RS
779 --summary-limit=*)
780 summary_limit="${1#--summary-limit=}"
781 isnumber "$summary_limit" || usage
782 ;;
28f9af5d
PY
783 --)
784 shift
785 break
786 ;;
787 -*)
788 usage
789 ;;
790 *)
791 break
792 ;;
793 esac
794 shift
795 done
bffe71f4 796
f2dc06a3
PY
797 test $summary_limit = 0 && return
798
3deea89c 799 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
800 then
801 head=$rev
caa9c3ca 802 test $# = 0 || shift
496eeeb1 803 elif test -z "$1" || test "$1" = "HEAD"
3deea89c 804 then
14e940d7
JH
805 # before the first commit: compare with an empty tree
806 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 807 test -z "$1" || shift
28f9af5d 808 else
3deea89c 809 head="HEAD"
28f9af5d
PY
810 fi
811
1c244f6e
JL
812 if [ -n "$files" ]
813 then
814 test -n "$cached" &&
465d6a00 815 die "$(gettext "The --cached option cannot be used with the --files option")"
1c244f6e
JL
816 diff_cmd=diff-files
817 head=
818 fi
819
28f9af5d 820 cd_to_toplevel
091a6eb0 821 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
28f9af5d 822 # Get modified modules cared by user
18076502 823 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 824 sane_egrep '^:([0-7]* )?160000' |
2be94509 825 while read mod_src mod_dst sha1_src sha1_dst status sm_path
28f9af5d
PY
826 do
827 # Always show modules deleted or type-changed (blob<->module)
496eeeb1
EP
828 if test "$status" = D || test "$status" = T
829 then
6a066230 830 printf '%s\n' "$sm_path"
496eeeb1
EP
831 continue
832 fi
927b26f8 833 # Respect the ignore setting for --for-status.
834 if test -n "$for_status"
835 then
0ea306ef 836 name=$(git submodule--helper name "$sm_path")
927b26f8 837 ignore_config=$(get_submodule_config "$name" ignore none)
496eeeb1 838 test $status != A && test $ignore_config = all && continue
927b26f8 839 fi
28f9af5d 840 # Also show added or modified modules which are checked out
2be94509 841 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
6a066230 842 printf '%s\n' "$sm_path"
28f9af5d
PY
843 done
844 )
1cb639e6 845
d0f64dd4
PY
846 test -z "$modules" && return
847
18076502 848 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 849 sane_egrep '^:([0-7]* )?160000' |
1cb639e6
PY
850 cut -c2- |
851 while read mod_src mod_dst sha1_src sha1_dst status name
852 do
853 if test -z "$cached" &&
854 test $sha1_dst = 0000000000000000000000000000000000000000
855 then
856 case "$mod_dst" in
857 160000)
858 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
859 ;;
860 100644 | 100755 | 120000)
861 sha1_dst=$(git hash-object $name)
862 ;;
863 000000)
864 ;; # removed
865 *)
866 # unexpected type
6ff875c5 867 eval_gettextln "unexpected mode \$mod_dst" >&2
1cb639e6
PY
868 continue ;;
869 esac
870 fi
871 missing_src=
872 missing_dst=
873
874 test $mod_src = 160000 &&
30353a40 875 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
876 missing_src=t
877
878 test $mod_dst = 160000 &&
30353a40 879 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 880 missing_dst=t
bffe71f4 881
44431df0 882 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
091a6eb0 883
1cb639e6
PY
884 total_commits=
885 case "$missing_src,$missing_dst" in
886 t,)
091a6eb0 887 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1cb639e6
PY
888 ;;
889 ,t)
091a6eb0 890 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
891 ;;
892 t,t)
091a6eb0 893 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
894 ;;
895 *)
896 errmsg=
897 total_commits=$(
496eeeb1 898 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6
PY
899 then
900 range="$sha1_src...$sha1_dst"
901 elif test $mod_src = 160000
902 then
903 range=$sha1_src
904 else
905 range=$sha1_dst
906 fi
907 GIT_DIR="$name/.git" \
b0e621ad 908 git rev-list --first-parent $range -- | wc -l
1cb639e6 909 )
eed35595 910 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
911 ;;
912 esac
913
914 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
915 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
916 if test $status = T
917 then
b3e73449
ÆAB
918 blob="$(gettext "blob")"
919 submodule="$(gettext "submodule")"
1cb639e6
PY
920 if test $mod_dst = 160000
921 then
091a6eb0 922 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 923 else
091a6eb0 924 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
925 fi
926 else
091a6eb0 927 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1cb639e6
PY
928 fi
929 if test -n "$errmsg"
930 then
931 # Don't give error msg for modification whose dst is not submodule
932 # i.e. deleted or changed to blob
933 test $mod_dst = 160000 && echo "$errmsg"
934 else
496eeeb1 935 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6 936 then
f2dc06a3
PY
937 limit=
938 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 939 GIT_DIR="$name/.git" \
f2dc06a3 940 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
941 --first-parent $sha1_src...$sha1_dst
942 elif test $mod_dst = 160000
943 then
944 GIT_DIR="$name/.git" \
945 git log --pretty='format: > %s' -1 $sha1_dst
946 else
947 GIT_DIR="$name/.git" \
948 git log --pretty='format: < %s' -1 $sha1_src
949 fi
950 echo
951 fi
952 echo
3ba7407b 953 done
28f9af5d 954}
70c7ac22 955#
941987a5 956# List all submodules, prefixed with:
70c7ac22
LH
957# - submodule not initialized
958# + different revision checked out
959#
960# If --cached was specified the revision in the index will be printed
961# instead of the currently checked out revision.
962#
963# $@ = requested paths (default to all)
964#
23a485e3 965cmd_status()
70c7ac22 966{
5c08dbbd
JH
967 # parse $args after "submodule ... status".
968 while test $# -ne 0
969 do
970 case "$1" in
971 -q|--quiet)
2e6a30ef 972 GIT_QUIET=1
5c08dbbd
JH
973 ;;
974 --cached)
975 cached=1
976 ;;
64b19ffe
JH
977 --recursive)
978 recursive=1
979 ;;
5c08dbbd
JH
980 --)
981 shift
982 break
983 ;;
984 -*)
985 usage
986 ;;
987 *)
988 break
989 ;;
990 esac
991 shift
992 done
993
b0f4b408
SB
994 {
995 git submodule--helper list --prefix "$wt_prefix" "$@" ||
c4c02bf1 996 echo "#unmatched" $?
b0f4b408 997 } |
64394e3a 998 while read mode sha1 stage sm_path
70c7ac22 999 do
c4c02bf1 1000 die_if_unmatched "$mode" "$sha1"
0ea306ef 1001 name=$(git submodule--helper name "$sm_path") || exit
5be60078 1002 url=$(git config submodule."$name".url)
44431df0 1003 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
313ee0d6
NMC
1004 if test "$stage" = U
1005 then
1006 say "U$sha1 $displaypath"
1007 continue
1008 fi
496eeeb1
EP
1009 if test -z "$url" ||
1010 {
1011 ! test -d "$sm_path"/.git &&
1012 ! test -f "$sm_path"/.git
1013 }
70c7ac22 1014 then
64b19ffe 1015 say "-$sha1 $displaypath"
70c7ac22
LH
1016 continue;
1017 fi
64394e3a 1018 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
70c7ac22 1019 then
b545cd15 1020 set_name_rev "$sm_path" "$sha1"
64b19ffe 1021 say " $sha1 $displaypath$revname"
70c7ac22
LH
1022 else
1023 if test -z "$cached"
1024 then
14111fc4 1025 sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
70c7ac22 1026 fi
b545cd15 1027 set_name_rev "$sm_path" "$sha1"
64b19ffe
JH
1028 say "+$sha1 $displaypath$revname"
1029 fi
1030
1031 if test -n "$recursive"
1032 then
1033 (
1034 prefix="$displaypath/"
14111fc4 1035 sanitize_submodule_env
10450cf7 1036 wt_prefix=
64394e3a 1037 cd "$sm_path" &&
e15bec0e 1038 eval cmd_status
64b19ffe 1039 ) ||
64394e3a 1040 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
70c7ac22
LH
1041 fi
1042 done
1043}
2327f61e
DA
1044#
1045# Sync remote urls for submodules
1046# This makes the value for remote.$remote.url match the value
1047# specified in .gitmodules.
1048#
1049cmd_sync()
1050{
1051 while test $# -ne 0
1052 do
1053 case "$1" in
1054 -q|--quiet)
2e6a30ef 1055 GIT_QUIET=1
2327f61e
DA
1056 shift
1057 ;;
82f49f29
PH
1058 --recursive)
1059 recursive=1
1060 shift
1061 ;;
2327f61e
DA
1062 --)
1063 shift
1064 break
1065 ;;
1066 -*)
1067 usage
1068 ;;
1069 *)
1070 break
1071 ;;
1072 esac
1073 done
1074 cd_to_toplevel
b0f4b408
SB
1075 {
1076 git submodule--helper list --prefix "$wt_prefix" "$@" ||
c4c02bf1 1077 echo "#unmatched" $?
b0f4b408 1078 } |
64394e3a 1079 while read mode sha1 stage sm_path
2327f61e 1080 do
c4c02bf1 1081 die_if_unmatched "$mode" "$sha1"
0ea306ef 1082 name=$(git submodule--helper name "$sm_path")
2327f61e 1083 url=$(git config -f .gitmodules --get submodule."$name".url)
baede9f8
JH
1084
1085 # Possibly a url relative to parent
1086 case "$url" in
1087 ./*|../*)
967b2c66
JS
1088 # rewrite foo/bar as ../.. to find path from
1089 # submodule work tree to superproject work tree
6a066230 1090 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
967b2c66
JS
1091 # guarantee a trailing /
1092 up_path=${up_path%/}/ &&
1093 # path from submodule work tree to submodule origin repo
63e95beb 1094 sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
967b2c66 1095 # path from superproject work tree to submodule origin repo
63e95beb 1096 super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
967b2c66
JS
1097 ;;
1098 *)
1099 sub_origin_url="$url"
1100 super_config_url="$url"
baede9f8
JH
1101 ;;
1102 esac
1103
ccee6086 1104 if git config "submodule.$name.url" >/dev/null 2>/dev/null
2327f61e 1105 then
44431df0 1106 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
091a6eb0 1107 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
967b2c66 1108 git config submodule."$name".url "$super_config_url"
ccee6086 1109
64394e3a 1110 if test -e "$sm_path"/.git
ccee6086
JH
1111 then
1112 (
14111fc4 1113 sanitize_submodule_env
64394e3a 1114 cd "$sm_path"
ccee6086 1115 remote=$(get_default_remote)
967b2c66 1116 git config remote."$remote".url "$sub_origin_url"
82f49f29
PH
1117
1118 if test -n "$recursive"
1119 then
1120 prefix="$prefix$sm_path/"
1121 eval cmd_sync
1122 fi
ccee6086
JH
1123 )
1124 fi
2327f61e
DA
1125 fi
1126 done
1127}
70c7ac22 1128
5c08dbbd
JH
1129# This loop parses the command line arguments to find the
1130# subcommand name to dispatch. Parsing of the subcommand specific
1131# options are primarily done by the subcommand implementations.
1132# Subcommand specific options such as --branch and --cached are
1133# parsed here as well, for backward compatibility.
1134
1135while test $# != 0 && test -z "$command"
70c7ac22
LH
1136do
1137 case "$1" in
cf419828 1138 add | foreach | init | deinit | update | status | summary | sync)
5c08dbbd 1139 command=$1
70c7ac22
LH
1140 ;;
1141 -q|--quiet)
2e6a30ef 1142 GIT_QUIET=1
70c7ac22 1143 ;;
ecda0723
SV
1144 -b|--branch)
1145 case "$2" in
1146 '')
1147 usage
1148 ;;
1149 esac
1150 branch="$2"; shift
1151 ;;
70c7ac22 1152 --cached)
28f9af5d 1153 cached="$1"
70c7ac22
LH
1154 ;;
1155 --)
1156 break
1157 ;;
1158 -*)
1159 usage
1160 ;;
1161 *)
1162 break
1163 ;;
1164 esac
1165 shift
1166done
1167
5c08dbbd 1168# No command word defaults to "status"
af9c9f97
RR
1169if test -z "$command"
1170then
1171 if test $# = 0
1172 then
1173 command=status
1174 else
1175 usage
1176 fi
1177fi
5c08dbbd
JH
1178
1179# "-b branch" is accepted only by "add"
1180if test -n "$branch" && test "$command" != add
1181then
ecda0723 1182 usage
5c08dbbd
JH
1183fi
1184
28f9af5d 1185# "--cached" is accepted only by "status" and "summary"
496eeeb1 1186if test -n "$cached" && test "$command" != status && test "$command" != summary
5c08dbbd 1187then
70c7ac22 1188 usage
5c08dbbd
JH
1189fi
1190
1191"cmd_$command" "$@"